/*
 * This file is generated by jOOQ.
 */
package be.lghs.accounting.model.tables;


import be.lghs.accounting.model.Accounting;
import be.lghs.accounting.model.Keys;
import be.lghs.accounting.model.tables.records.CodasRecord;

import java.util.Arrays;
import java.util.List;
import java.util.UUID;

import javax.annotation.processing.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row5;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.14.9",
        "schema version:accounting_0010"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Codas extends TableImpl<CodasRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>accounting.codas</code>
     */
    public static final Codas CODAS = new Codas();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<CodasRecord> getRecordType() {
        return CodasRecord.class;
    }

    /**
     * The column <code>accounting.codas.id</code>.
     */
    public final TableField<CodasRecord, UUID> ID = createField(DSL.name("id"), SQLDataType.UUID.nullable(false).defaultValue(DSL.field("uuid_generate_v4()", SQLDataType.UUID)), this, "");

    /**
     * The column <code>accounting.codas.filename</code>.
     */
    public final TableField<CodasRecord, String> FILENAME = createField(DSL.name("filename"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>accounting.codas.content</code>.
     */
    public final TableField<CodasRecord, byte[]> CONTENT = createField(DSL.name("content"), SQLDataType.BLOB.nullable(false), this, "");

    /**
     * The column <code>accounting.codas.account_id</code>.
     */
    public final TableField<CodasRecord, UUID> ACCOUNT_ID = createField(DSL.name("account_id"), SQLDataType.UUID.nullable(false), this, "");

    /**
     * The column <code>accounting.codas.sequence_number</code>.
     */
    public final TableField<CodasRecord, Integer> SEQUENCE_NUMBER = createField(DSL.name("sequence_number"), SQLDataType.INTEGER.nullable(false), this, "");

    private Codas(Name alias, Table<CodasRecord> aliased) {
        this(alias, aliased, null);
    }

    private Codas(Name alias, Table<CodasRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>accounting.codas</code> table reference
     */
    public Codas(String alias) {
        this(DSL.name(alias), CODAS);
    }

    /**
     * Create an aliased <code>accounting.codas</code> table reference
     */
    public Codas(Name alias) {
        this(alias, CODAS);
    }

    /**
     * Create a <code>accounting.codas</code> table reference
     */
    public Codas() {
        this(DSL.name("codas"), null);
    }

    public <O extends Record> Codas(Table<O> child, ForeignKey<O, CodasRecord> key) {
        super(child, key, CODAS);
    }

    @Override
    public Schema getSchema() {
        return Accounting.ACCOUNTING;
    }

    @Override
    public UniqueKey<CodasRecord> getPrimaryKey() {
        return Keys.CODAS_PKEY;
    }

    @Override
    public List<UniqueKey<CodasRecord>> getKeys() {
        return Arrays.<UniqueKey<CodasRecord>>asList(Keys.CODAS_PKEY, Keys.CODAS_FILENAME_KEY);
    }

    @Override
    public List<ForeignKey<CodasRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<CodasRecord, ?>>asList(Keys.CODAS__CODAS_ACCOUNT_ID_FKEY);
    }

    private transient Accounts _accounts;

    public Accounts accounts() {
        if (_accounts == null)
            _accounts = new Accounts(this, Keys.CODAS__CODAS_ACCOUNT_ID_FKEY);

        return _accounts;
    }

    @Override
    public Codas as(String alias) {
        return new Codas(DSL.name(alias), this);
    }

    @Override
    public Codas as(Name alias) {
        return new Codas(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Codas rename(String name) {
        return new Codas(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Codas rename(Name name) {
        return new Codas(name, null);
    }

    // -------------------------------------------------------------------------
    // Row5 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row5<UUID, String, byte[], UUID, Integer> fieldsRow() {
        return (Row5) super.fieldsRow();
    }
}
